### Method

# Gio File query_settable_attributes

#### Declaration

    GFileAttributeInfoList*
    g_file_query_settable_attributes (
      GFile* file,
      GCancellable* cancellable,
      GError** error
    )

#### Description

Obtain the list of settable attributes for the file.

Returns the type and full attribute name of all the attributes that can be set on this file. This doesn’t mean setting it will always succeed though, you might get an access failure, or some specific file may not support a specific attribute.

If `cancellable` is not `NULL`, then the operation can be cancelled by triggering the cancellable object from another thread. If the operation was cancelled, the error `G_IO_ERROR_CANCELLED` will be returned.

#### Parameters

`cancellable`

  Type: `GCancellable`

  Optional `GCancellable` object, `NULL` to ignore.

  The argument can be `NULL`.
  The data is owned by the caller of the method.

`error`

  Type: `GError **`

  The return location for a recoverable error.

  The argument can be `NULL`.
  If the return location is not `NULL`, then you must initialize it to a `NULL` `GError*`.
  The argument will be left initialized to `NULL` by the method if there are no errors.
  In case of error, the argument will be set to a newly allocated `GError`; the caller will take ownership of the data, and be responsible for freeing it.

#### Return value

Type: `GFileAttributeInfoList`

A `GFileAttributeInfoList` describing the settable attributes. When you are done with it, release it with `g_file_attribute_info_list_unref()`

The caller of the method takes ownership of the data, and is responsible for freeing it.